;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Sonic Cheater v1.20     ;
; Created by Damian Grove ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Source code:                                                               ;
;   This source is compatible with any standard 80x86 ASM compile. I use A86 ;
;   to compile this source. This source has been provided to you as is. I am ;
;   not responsible for any problems you may encounter when using my code or ;
;   the software itself.                                                     ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


jmp	start


;;;;;;;;;;;;;;;;;;;;;;;;
; Variable definitions ;
;;;;;;;;;;;;;;;;;;;;;;;;
enterfile		db	"Enter the filename of the savestate you wish to modify: $"
entergame		db	"Type the game number", 13, 10
			db	"    1 - S1, S2, S3", 13, 10
			db	"    2 - SK, S3K", 13, 10
			db	"    3 - S2K", 13, 10, 13, 10, "$"
filename		db	128 dup(?)
gamedef		db	0
error1		db	13,10,"ERROR - Unable to open file",13,10,13,10,"$"
error2		db	13,10,13,10,"ERROR - Invalid game type",13,10,13,10,"$"
enable1		dw	0101h
enable2		db	1
dtline		db	80 dup(""), "$"
scheater		db	"Sonic Cheater v1.20",13,10,"$"
created		db	"Created by Damian Grove",13,10,"$"
compile		db	"COMPILE: December 27, 2001",13,10,"$"
dbline		db	80 dup(""), 13, 10,"$"
patched		db	13,10,13,10,"File successfully patched!",13,10,13,10,"$"
address1		dw	2448h
address2		dw	244ah


;;;;;;;;;;;
; Startup ;
;;;;;;;;;;;
start:
mov	ah, 09h
mov	dx, offset dtline
int	21h
mov	al, 0
mov	dx, offset scheater
int	21h
mov	al, 0
mov	dx, offset created
int	21h
mov	al, 0
mov	dx, offset compile
int	21h
mov	al, 0
mov	dx, offset dbline
int	21h


;;;;;;;;;;;;;
; Open file ;
;;;;;;;;;;;;;
openfile:
mov	al, 0
mov	dx, offset enterfile
int	21h

mov	dx, offset filename
mov	ax, 3f00h
xor	bx, bx
mov	cx, 128			; Accept a 128 character input
int	21h

mov	di, offset filename	; Append a NULL
add	di, ax
sub	di, 2
xor	al, al
stosb

mov	ax, 3d02h
mov	dx, offset filename
int	21h
jnc	opensuccess

mov	ax, 0900h
mov	dx, offset error1
int	21h
jmp	quit


;;;;;;;;;;;;;;;;;;;
; Check game type ;
;;;;;;;;;;;;;;;;;;;
opensuccess:
mov	bx, ax
push	bx				; Save the file handle for later use
mov	ax, 0900h
mov	dx, offset entergame
int	21h

mov	ax, 0
int	16h

push	ax
mov	dl, al
mov	ah, 2
int	21h
pop	ax

checkfor1:
cmp	al, "1"
jne	checkfor2
mov	al, 1
mov	gamedef, al			; Set gamedef variable to 1 (S1, S2, S3)
jmp	writevalues

checkfor2:
cmp	al, "2"
jne	checkfor3
mov	al, 2
mov	gamedef, al			; Set gamedef variable to 2 (SK, S3K)
jmp	writevalues

checkfor3:
cmp	al, "3"
jne	invalidgametype
mov	al, 3
mov	gamedef, al			; Set gamedef variable to 3 (SK, S3K)
mov	ax, 2380h
mov	address1, ax
mov	ax, 2382h
mov	address2, ax
jmp	writevalues

invalidgametype:
mov	ax, 0900h
mov	dx, offset error2
int	21h
jmp	quit


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Set address of file (slow motion / level select) ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
writevalues:
pop	bx
push	bx
mov	ax, 4200h
mov	cx, 1
mov	dx, address1		; Set address for slow motion and level select
int	21h

;;;;;;;;;;;;;;;;;
; Write to file ;
;;;;;;;;;;;;;;;;;
mov	ah, 40h
pop	bx
push	bx
mov	cx, 2				; Write 2 bytes
mov	dx, offset enable1	; Write 0101 to address
int	21h


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Set address of file (extra) ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pop	bx
push	bx
mov	ax, 4200h
mov	cx, 1
mov	dx, address2		; Set address for extra data?
int	21h


;;;;;;;;;;;;;;;;;
; Write to file ;
;;;;;;;;;;;;;;;;;
mov	ah, 40h
pop	bx
push	bx
mov	cx, 2				; Write 2 bytes
mov	dx, offset enable1	; Write 0101 to address
int	21h


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Set address of file (debug) ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pop	bx
push	bx
mov	ax, 4200h
mov	cx, 1
cmp	gamedef, 1
je	set2472
jne	set2452

set2452:
mov	dx, 2452h			; Set address for debug mode (gamedef = 2 or 3)
int	21h
jmp	write24x2

set2472:
mov	dx, 2472h			; Set address for debug mode (gamedef = 1)
int	21h


;;;;;;;;;;;;;;;;;
; Write to file ;
;;;;;;;;;;;;;;;;;
write24x2:
mov	ah, 40h
pop	bx
mov	cx, 1				; Write 1 byte
mov	dx, offset enable2	; Write 01 to address
int	21h

mov	ax, 0900h
mov	dx, offset patched
int	21h


;;;;;;;;;;;;;;;;;
; Return to DOS ;
;;;;;;;;;;;;;;;;;
quit:
mov	ax, 4c00h
int	21h